using System;
using System.Data;
using System.Configuration;
using System.Diagnostics;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using Microsoft.SharePoint;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Microsoft.Reporting.WebForms;
using System.IO;
using System.Text;
using System.Xml;
public partial class RMReport : System.Web.UI.Page
{
   

    public MemoryStream GenerateRdl(ArrayList m_fields)
    {
        int namegen = 0;//for name generating
        int fieldWidth = 2;
        // Open a new RDL file stream for writing
        MemoryStream stream = new MemoryStream();
        //stream = File.OpenWrite("Report1.rdl");
        XmlTextWriter writer = new XmlTextWriter(stream, Encoding.UTF8);

        // Causes child elements to be indented
        writer.Formatting = Formatting.Indented;

        // Report element
        writer.WriteProcessingInstruction("xml", "version=\"1.0\" encoding=\"utf-8\"");
        writer.WriteStartElement("Report");
        writer.WriteAttributeString("xmlns", null, "http://schemas.microsoft.com/sqlserver/reporting/2003/10/reportdefinition");
        writer.WriteElementString("Width", "6in");

        // DataSource element
        writer.WriteStartElement("DataSources");
        writer.WriteStartElement("DataSource");
        writer.WriteAttributeString("Name", null, "DummyDataSource");
        writer.WriteStartElement("ConnectionProperties");
        writer.WriteElementString("DataProvider", "SQL");
        writer.WriteElementString("ConnectString", "");
        writer.WriteElementString("IntegratedSecurity", "true");
        writer.WriteEndElement(); // ConnectionProperties
        writer.WriteEndElement(); // DataSource
        writer.WriteEndElement(); // DataSources

        // DataSet element
        writer.WriteStartElement("DataSets");
        writer.WriteStartElement("DataSet");
        writer.WriteAttributeString("Name", null, "DataSet1_DataTable1");

        // Query element
        writer.WriteStartElement("Query");
        writer.WriteElementString("DataSourceName", "DummyDataSource");
        writer.WriteElementString("CommandType", "Text");
        writer.WriteElementString("CommandText", "");
        writer.WriteElementString("Timeout", "30");
        writer.WriteEndElement(); // Query

        // Fields elements
        writer.WriteStartElement("Fields");
        namegen = 0;
        foreach (string fieldName in m_fields)
        {
            namegen++;
            writer.WriteStartElement("Field");
            writer.WriteAttributeString("Name", null, "Name" + namegen.ToString());//ReplaceSpace(fieldName));
            writer.WriteElementString("DataField", null, fieldName);
            writer.WriteEndElement(); // Field
        }

        // End previous elements
        writer.WriteEndElement(); // Fields
        writer.WriteEndElement(); // DataSet
        writer.WriteEndElement(); // DataSets

        // Body element
        writer.WriteStartElement("Body");
        writer.WriteElementString("Height", "5in");

        // ReportItems element
        writer.WriteStartElement("ReportItems");

        // Table element
        writer.WriteStartElement("Table");
        writer.WriteAttributeString("Name", null, "Table1");
        writer.WriteElementString("DataSetName", "DataSet1_DataTable1");
        writer.WriteElementString("Top", ".5in");
        writer.WriteElementString("Left", ".5in");
        writer.WriteElementString("Height", ".5in");
        writer.WriteElementString("Width", (m_fields.Count * fieldWidth) + "in");

        // Table Columns
        writer.WriteStartElement("TableColumns");
        for (int i = 0; i < m_fields.Count; i++)
        {
            writer.WriteStartElement("TableColumn");
            writer.WriteElementString("Width", fieldWidth.ToString() +"in");
            writer.WriteEndElement(); // TableColumn
        }
        writer.WriteEndElement(); // TableColumns

        // Header Row
        writer.WriteStartElement("Header");
        writer.WriteStartElement("TableRows");
        writer.WriteStartElement("TableRow");
        writer.WriteElementString("Height", ".25in");
        writer.WriteStartElement("TableCells");
        namegen = 0;
        foreach (string fieldName in m_fields)
        {
            namegen++;
            writer.WriteStartElement("TableCell");
            writer.WriteStartElement("ReportItems");
            
            // Textbox
            writer.WriteStartElement("Textbox");
            writer.WriteAttributeString("Name", null, "Header" + "Name" + namegen.ToString());// ReplaceSpace(fieldName));

            writer.WriteStartElement("Style");
            writer.WriteStartElement("BorderStyle");
            writer.WriteElementString("Default", "Solid");
            writer.WriteEndElement(); // BorderStyleStyle
            writer.WriteElementString("PaddingLeft", "2pt");
            writer.WriteElementString("PaddingBottom", "2pt");
            writer.WriteElementString("PaddingRight", "2pt");
            writer.WriteElementString("PaddingTop", "2pt");
            writer.WriteElementString("BackgroundColor", "Silver");
            //writer.WriteElementString("TextDecoration", "Underline");
            writer.WriteEndElement(); // Style
            writer.WriteElementString("CanGrow", "true");
            //writer.WriteElementString("Top", "0in");
           // writer.WriteElementString("Left", "0in");
           // writer.WriteElementString("Height", ".5in");
           // writer.WriteElementString("Width", fieldWidth.ToString() + "in");
            writer.WriteElementString("Value", fieldName);
            writer.WriteEndElement(); // Textbox

            writer.WriteEndElement(); // ReportItems
            writer.WriteEndElement(); // TableCell
           
        }

        writer.WriteEndElement(); // TableCells
        writer.WriteEndElement(); // TableRow
        writer.WriteEndElement(); // TableRows
        writer.WriteEndElement(); // Header

        // Details Row
        writer.WriteStartElement("Details");
        writer.WriteStartElement("TableRows");
        writer.WriteStartElement("TableRow");
        writer.WriteElementString("Height", ".25in");
        writer.WriteStartElement("TableCells");
        namegen = 0;
        foreach (string fieldName in m_fields)
        {
            namegen++;
            writer.WriteStartElement("TableCell");
            writer.WriteStartElement("ReportItems");

            // Textbox
            writer.WriteStartElement("Textbox");
            writer.WriteAttributeString("Name", null, "Name" + namegen.ToString());// ReplaceSpace(fieldName));

            writer.WriteStartElement("Style");

            writer.WriteStartElement("BorderStyle");
            writer.WriteElementString("Default", "Solid");
            writer.WriteEndElement(); // BorderStyleStyle
            writer.WriteElementString("PaddingLeft", "2pt");
            writer.WriteElementString("PaddingBottom", "2pt");
            writer.WriteElementString("PaddingRight", "2pt");
            writer.WriteElementString("PaddingTop", "2pt");
            //writer.WriteElementString("TextDecoration", "Underline");
            writer.WriteEndElement(); // Style
            writer.WriteElementString("CanGrow", "true");

            //writer.WriteEndElement(); // Style

            //writer.WriteElementString("Top", "0in");
            //writer.WriteElementString("Left", "0in");
           // writer.WriteElementString("Height", ".5in");
            //writer.WriteElementString("Width", fieldWidth.ToString() + "in");
            writer.WriteElementString("Value", "=Fields!" + "Name" + namegen.ToString() + ".Value");
           // writer.WriteElementString("HideDuplicates", "DataSet1_DataTable1");
            writer.WriteEndElement(); // Textbox

            writer.WriteEndElement(); // ReportItems
            writer.WriteEndElement(); // TableCell
        }

        // End Details element and children   
        writer.WriteEndElement(); // TableCells
        writer.WriteEndElement(); // TableRow
        writer.WriteEndElement(); // TableRows
        writer.WriteEndElement(); // Details

        // End table element and end report definition file
        writer.WriteEndElement(); // Table
        writer.WriteEndElement(); // ReportItems
        writer.WriteEndElement(); // Body
        writer.WriteEndElement(); // Report

        // Flush the writer and close the stream
        writer.Flush();
        //stream.Close();
        stream.Position = 0;
        return stream;
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        // make some datatable, you can change COLUMNS and have different columns quantity
         int COLUMNS = 3;
         if (Request.QueryString["col"] != null)
             COLUMNS = int.Parse(Request.QueryString["col"]);
         DataTable table = new DataTable();
         table.TableName = "DataSet1_DataTable1";
         int i;
        for( i =0; i<COLUMNS; i++)
          table.Columns.Add("column" + i.ToString());

        DataRow datarow = table.NewRow();
        i = 0;     
        foreach (DataColumn column in table.Columns)
        {
            datarow[column] = "value" + i.ToString();
            i++;
        }
        table.Rows.Add(datarow);
        // now make rdlc on the fly
        ArrayList fields = new ArrayList();
        foreach (DataColumn clm in table.Columns)
            fields.Add(clm.ColumnName);
        ReportViewer1.LocalReport.LoadReportDefinition(GenerateRdl(fields));


        //Debug.Assert(dt!=null,"dt =null");
        ReportDataSource rds = new ReportDataSource();
        rds.Name = table.TableName;
        rds.Value = table;
        ReportViewer1.LocalReport.DataSources.Add(rds);
    }

  
}
